## heaptrack 1.3.0

=== CMakeLists.txt ===
if (CMAKE_VERSION VERSION_LESS "2.8.12")
    cmake_minimum_required(VERSION 2.8.9)
    set(HEAPTRACK_BUILD_GUI OFF)
else()
    cmake_minimum_required(VERSION 2.8.12)
endif()

project(heaptrack)
enable_testing()

if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to 'RelWithDebInfo' as none was specified.")
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build." FORCE)
endif()

set(HEAPTRACK_VERSION_MAJOR 1)
set(HEAPTRACK_VERSION_MINOR 3)
set(HEAPTRACK_VERSION_PATCH 0)
set(HEAPTRACK_LIB_VERSION 1.3.0)
set(HEAPTRACK_LIB_SOVERSION 2)
set(HEAPTRACK_FILE_FORMAT_VERSION 3)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

option(APPIMAGE_BUILD "configure build for bundling in an appimage" OFF)

set(REQUIRED_IN_APPIMAGE "")
if (APPIMAGE_BUILD)
    set(REQUIRED_IN_APPIMAGE REQUIRED)
endif()

include(FeatureSummary)
find_package(Boost 1.60.0 ${REQUIRED_IN_APPIMAGE} COMPONENTS system filesystem iostreams container)
set_package_properties(Boost PROPERTIES TYPE RECOMMENDED PURPOSE "Boost container libraries can greatly improve performance (via pmr allocators)")
find_package(Threads REQUIRED)
find_package(ZLIB REQUIRED)

if (${Boost_IOSTREAMS_FOUND})
    find_package(ZSTD ${REQUIRED_IN_APPIMAGE})

    include(CheckCXXSourceCompiles)
    include(CMakePushCheckState)
    cmake_push_check_state()
    set(CMAKE_REQUIRED_INCLUDES ${Boost_INCLUDE_DIRS})
    set(CMAKE_REQUIRED_LIBRARIES ${Boost_LIBRARIES})
    check_cxx_source_compiles("#include <boost/iostreams/filter/zstd.hpp>
        int main() { boost::iostreams::zstd_decompressor(); return 0; }"
        BOOST_IOSTREAMS_HAS_ZSTD
    )
    cmake_pop_check_state()
endif()
set_package_properties(ZSTD PROPERTIES TYPE RECOMMENDED PURPOSE "Zstandard offers better (de)compression performance compared with gzip/zlib, making heaptrack faster and datafiles smaller.")

if (CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
    set(HEAPTRACK_BUILD_TRACK_DEFAULT ON)
    set(HEAPTRACK_BUILD_INTERPRET_DEFAULT ON)
else()
    set(HEAPTRACK_BUILD_TRACK_DEFAULT OFF)
    set(HEAPTRACK_BUILD_INTERPRET_DEFAULT OFF)
endif()

option(
  HEAPTRACK_BUILD_TRACK
  "Disable this option to skip building the tracker part for heaptrack, e.g. to only build the GUI."
  ${HEAPTRACK_BUILD_TRACK_DEFAULT}
)

option(
  HEAPTRACK_BUILD_BACKTRACE
  "Enable this option to build libbacktrace. It will be enabled implicitly if HEAPTRACK_BUILD_INTERPRET is enabled."
  OFF
)

option(
  HEAPTRACK_BUILD_INTERPRET
  "Disable this option to skip building the interpret part for heaptrack."
  ${HEAPTRACK_BUILD_INTERPRET_DEFAULT}
)

if (HEAPTRACK_BUILD_INTERPRET)
    set(HEAPTRACK_BUILD_BACKTRACE ON)
endif()

if (CMAKE_CROSSCOMPILING)
    set(HEAPTRACK_BUILD_ANALYZE_DEFAULT OFF)
else()
    set(HEAPTRACK_BUILD_ANALYZE_DEFAULT ON)
endif()

option(
  HEAPTRACK_BUILD_PRINT
  "Disable this option to skip building heaptrack_print, e.g. when you're cross-compiling."
  ${HEAPTRACK_BUILD_ANALYZE_DEFAULT}
)

option(
  HEAPTRACK_BUILD_GUI
  "Disable this option to skip building the Qt5 / KF5 based GUI for heaptrack."
  ${HEAPTRACK_BUILD_ANALYZE_DEFAULT}
)

option(
  HEAPTRACK_USE_LIBUNWIND
  "Define preferred unwind functionality - Libunwind as ON and unwind_tables as OFF."
  ON
)

set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

if (NOT MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wpedantic")
endif()

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED TRUE)

include (CheckCXXSourceCompiles)

# cfree() does not exist in glibc 2.26+.
# See: https://bugs.kde.org/show_bug.cgi?id=383889
include(CheckSymbolExists)
check_symbol_exists(cfree malloc.h HAVE_CFREE)
check_symbol_exists(valloc stdlib.h HAVE_VALLOC)

set(BIN_INSTALL_DIR "bin")
set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")
set(LIB_INSTALL_DIR "lib${LIB_SUFFIX}")
set(LIBEXEC_INSTALL_DIR "${LIB_INSTALL_DIR}/heaptrack/libexec")

file(RELATIVE_PATH LIBEXEC_REL_PATH
    "${CMAKE_INSTALL_PREFIX}/${BIN_INSTALL_DIR}"
    "${CMAKE_INSTALL_PREFIX}/${LIBEXEC_INSTALL_DIR}")

file(RELATIVE_PATH LIB_REL_PATH
    "${CMAKE_INSTALL_PREFIX}/${BIN_INSTALL_DIR}"
    "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}/heaptrack")

set(ECM_ENABLE_SANITIZERS "" CACHE STRING "semicolon-separated list of sanitizers to enable for code that is not injected into client applications")

if (ECM_ENABLE_SANITIZERS)
    find_package(ECM 1.0.0 NO_MODULE)
    if (ECM_FOUND)
        set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})
    endif()
endif()

if (HEAPTRACK_BUILD_TRACK)
    if (HEAPTRACK_USE_LIBUNWIND)
        find_package(Libunwind REQUIRED)
    endif()

    check_cxx_source_compiles(
        "#ifdef __linux__
        #include <stdio_ext.h>
        #endif
        #include <fcntl.h>
        #include <dlfcn.h>
        #include <link.h>
        int main() { return 0; }"
        HAVE_LINUX_HEADERS)

    if (NOT HAVE_LINUX_HEADERS)
        message(FATAL_ERROR "You are missing some Linux/BSD headers required to compile heaptrack.")
    endif()
endif()

add_subdirectory(3rdparty)
include_directories(3rdparty/robin-map/include)
add_subdirectory(src)
add_subdirectory(tests)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

find_package(KF5I18n CONFIG REQUIRED)
ki18n_install(po)

=== 3rdparty/CMakeLists.txt ===
if (ECM_FOUND)
    include(ECMEnableSanitizers)
endif()

if (HEAPTRACK_BUILD_BACKTRACE)
    add_subdirectory(libbacktrace)
endif()

if (ZSTD_FOUND AND NOT BOOST_IOSTREAMS_HAS_ZSTD)
    add_subdirectory(boost-zstd)
endif()

=== 3rdparty/boost-zstd/CMakeLists.txt ===
include_directories(
    ${ZSTD_INCLUDE_DIR}
    ${Boost_INCLUDE_DIRS}
)

add_library(boost-zstd STATIC zstd.cpp)
target_link_libraries(boost-zstd LINK_PUBLIC
    ${ZSTD_LIBRARY}
)

=== 3rdparty/libbacktrace/CMakeLists.txt ===
# based on: https://github.com/ValveSoftware/vogl/blob/master/src/libbacktrace/CMakeLists.txt
#
#    CMakeLists.txt -- libbacktrace CMake build script
#    Contributed by Alexander Monakov, ISP RAS
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     (1) Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#
#     (2) Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in
#     the documentation and/or other materials provided with the
#     distribution.
#
#     (3) The name of the author may not be used to
#     endorse or promote products derived from this software without
#     specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
# IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.  */

cmake_minimum_required (VERSION 2.8)

project (libbacktrace)

set (BACKTRACE_SUPPORTED 1)

add_definitions("-DHAVE_STDINT_H")

include (CheckSymbolExists)
if (true)
    # When unwind.h is in /usr/local/include, check_symbol_exists() is failing. But
    #  these functions are in the Linux Standard Base Core Spec and should just exist
    #  for Linux, yes?  I'm assuming that's the case for now and using them.
    #  (Otherwise stack tracing won't work anyway).
    set (HAVE_BACKTRACE 1)
    set (HAVE_GETIPINFO 1)
else()
    check_symbol_exists (_Unwind_Backtrace unwind.h HAVE_BACKTRACE)
    check_symbol_exists (_Unwind_GetIPInfo unwind.h HAVE_GETIPINFO)
endif()

if (HAVE_BACKTRACE)
    set (BACKTRACE_FILE backtrace.c simple.c)
else ()
    message(FATAL_ERROR "Could not find unwind.h, install the libunwind development package.")
endif ()

include (CheckCCompilerFlag)
check_c_compiler_flag ("-funwind-tables" FLAG_UNWIND_TABLES)
if (FLAG_UNWIND_TABLES)
    add_definitions ("-funwind-tables")
endif ()

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_definitions("-D_DEBUG -DDEBUG")
endif()

# Adjust warnings
if (CMAKE_COMPILER_IS_GNUCC)
    add_definitions ("-Wno-switch -Wno-enum-compare")
endif ()

# Add these compiler options to match how voglcore and voglcommon are compiled, and to get libbacktrace compiling with gcc.
# -fno-strict-aliasing is particularly important if voglcore is called, and -fvisibility=hidden must be used otherwide symbols from this lib could be made visible in libvogltrace.
add_definitions ("-g -fno-omit-frame-pointer -fno-strict-aliasing -fno-math-errno -fvisibility=hidden")
SET(CMAKE_CXX_FLAGS_RELEASE "-O2 -g -DNDEBUG")

if ("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
   if ( NOT BUILD_X64 )
      # Fix startup crash in dlopen_notify_callback (called indirectly from our dlopen() function) when tracing glxspheres on my AMD dev box (x86 release only)
      #add_definitions ("-mstack-alignment=8")
   endif()
endif()

# clang doesn't print colored diagnostics when invoked from Ninja
if ("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
  if (UNIX AND CMAKE_GENERATOR STREQUAL "Ninja")
      add_definitions ("-fcolor-diagnostics")
  endif()
endif()

check_c_source_compiles (
    "int i;
    int main() {
    __sync_bool_compare_and_swap (&i, i, i);
    __sync_lock_test_and_set (&i, 1);
    __sync_lock_release (&i);}"
    HAVE_SYNC_FUNCTIONS)

check_c_source_compiles (
    "int i;
    int main() {
    __atomic_load_n (&i, __ATOMIC_ACQUIRE);
    __atomic_store_n (&i, i, __ATOMIC_RELEASE);}"
    HAVE_ATOMIC_FUNCTIONS)

if (HAVE_SYNC_FUNCTIONS OR HAVE_ATOMIC_FUNCTIONS)
    set (BACKTRACE_SUPPORTS_THREADS 1)
else ()
    set (BACKTRACE_SUPPORTS_THREADS 0)
endif ()

include(CMakeDetermineCompilerId)
if (CMAKE_EXECUTABLE_FORMAT STREQUAL "ELF")
    set (FORMAT_FILE elf.c dwarf.c)
    math (EXPR BACKTRACE_ELF_SIZE 8*${CMAKE_C_SIZEOF_DATA_PTR})
else ()
    message(FATAL_ERROR "Unknown executable format \"${CMAKE_EXECUTABLE_FORMAT}\", currently only ELF is supported.")
endif ()

check_symbol_exists (mmap sys/mman.h HAVE_MMAP)
check_symbol_exists(lstat sys/stat.h HAVE_LSTAT)
check_symbol_exists(readlink unistd.h HAVE_READLINK)

# NOTE: For the use-case of heaptrack, we want to use malloc for allocating
# the tiny fragments required for reading a backtrace as we are doing this
# in a separate process, outside of a potential signal handler
# This has a tremendous impact on the performance when analyzing the DWARF
# symbols of a large binary, such as clang++ or webkit.
set (ALLOC_FILE alloc.c)
set (BACKTRACE_USES_MALLOC 1)

if (HAVE_MMAP)
    set (VIEW_FILE mmapio.c)
    check_symbol_exists (MAP_ANONYMOUS sys/mman.h HAVE_MMAP_ANONYMOUS)
    check_symbol_exists (MAP_ANON sys/mman.h HAVE_MMAP_ANON)
else ()
    set (VIEW_FILE read.c)
endif ()

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_definitions("-D_DEBUG -DDEBUG")
endif()
add_definitions (-D_GNU_SOURCE)
set (CMAKE_REQUIRED_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS} -D_GNU_SOURCE)
check_symbol_exists (dl_iterate_phdr link.h HAVE_DL_ITERATE_PHDR)

include (CheckFunctionExists)
check_function_exists (fcntl HAVE_FCNTL)

check_function_exists (strnlen HAVE_DECL_STRNLEN)

check_function_exists (getexecname HAVE_GETEXECNAME)

configure_file (backtrace-supported.h.in backtrace-supported.h)

configure_file (config.h.in.cmake config.h)

include_directories (BEFORE
    ${CMAKE_CURRENT_BINARY_DIR}
)
include_directories (
    auxincl
    ../libdwarf
)

add_library (backtrace STATIC
    ${BACKTRACE_FILE}
    ${FORMAT_FILE}
    ${VIEW_FILE}
    ${ALLOC_FILE}
    atomic.c
    fileline.c
    posix.c
    print.c
    state.c
    sort.c
)

set_target_properties (backtrace PROPERTIES
    COMPILE_FLAGS "${CMAKE_SHARED_LIBRARY_C_FLAGS}"
)

=== 3rdparty/robin-map/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
include(GNUInstallDirs)


project(tsl-robin-map VERSION 0.6.3)

add_library(robin_map INTERFACE)
# Use tsl::robin_map as target, more consistent with other libraries conventions (Boost, Qt, ...)
add_library(tsl::robin_map ALIAS robin_map)

target_include_directories(robin_map INTERFACE
                           "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
                           "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")

list(APPEND headers "${CMAKE_CURRENT_SOURCE_DIR}/include/tsl/robin_growth_policy.h"
                    "${CMAKE_CURRENT_SOURCE_DIR}/include/tsl/robin_hash.h"
                    "${CMAKE_CURRENT_SOURCE_DIR}/include/tsl/robin_map.h"
                    "${CMAKE_CURRENT_SOURCE_DIR}/include/tsl/robin_set.h")
target_sources(robin_map INTERFACE "$<BUILD_INTERFACE:${headers}>")

if(MSVC)
    target_sources(robin_map INTERFACE
                   "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tsl-robin-map.natvis>"
                   "$<INSTALL_INTERFACE:${CMAKE_INSTALL_DATAROOTDIR}/tsl-robin-map.natvis>")
endif()




# Installation (only compatible with CMake version >= 3.3)
if(${CMAKE_VERSION} VERSION_GREATER "3.2")
    include(CMakePackageConfigHelpers)

    ## Install include directory and potential natvis file
    install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/include/tsl"
            DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

    if(MSVC)
        install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/tsl-robin-map.natvis"
                DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}")
    endif()



    ## Create and install tsl-robin-mapConfig.cmake
    configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/tsl-robin-mapConfig.cmake.in"
                                  "${CMAKE_CURRENT_BINARY_DIR}/tsl-robin-mapConfig.cmake"
                                  INSTALL_DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/cmake/tsl-robin-map")

    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/tsl-robin-mapConfig.cmake"
            DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/cmake/tsl-robin-map")



    ## Create and install tsl-robin-mapTargets.cmake
    install(TARGETS robin_map
            EXPORT tsl-robin-mapTargets)

    install(EXPORT tsl-robin-mapTargets
            NAMESPACE tsl::
            DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/cmake/tsl-robin-map")



    ## Create and install tsl-robin-mapConfigVersion.cmake
    # tsl-robin-map is header-only and does not depend on the architecture.
    # Remove CMAKE_SIZEOF_VOID_P from tsl-robin-mapConfigVersion.cmake so that a
    # tsl-robin-mapConfig.cmake generated for a 64 bit target can be used for 32 bit
    # targets and vice versa.
    set(CMAKE_SIZEOF_VOID_P_BACKUP ${CMAKE_SIZEOF_VOID_P})
    unset(CMAKE_SIZEOF_VOID_P)
    write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/tsl-robin-mapConfigVersion.cmake"
                                     COMPATIBILITY SameMajorVersion)
    set(CMAKE_SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P_BACKUP})

    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/tsl-robin-mapConfigVersion.cmake"
            DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/cmake/tsl-robin-map")
endif()

=== src/analyze/CMakeLists.txt ===
if (ECM_FOUND)
    include(ECMEnableSanitizers)
endif()

find_package(Boost 1.41.0 REQUIRED COMPONENTS iostreams program_options system filesystem)

configure_file(analyze_config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/analyze_config.h)

include_directories(
    ${Boost_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}/3rdparty/
    ${CMAKE_CURRENT_BINARY_DIR}
)

add_library(sharedprint STATIC
    accumulatedtracedata.cpp
    suppressions.cpp
)

target_link_libraries(sharedprint LINK_PUBLIC
    ${Boost_LIBRARIES}
    ${ZLIB_LIBRARIES}
)

if (ZSTD_FOUND AND NOT BOOST_IOSTREAMS_HAS_ZSTD)
    target_link_libraries(sharedprint LINK_PUBLIC
        boost-zstd
    )
endif()

add_subdirectory(print)

if(HEAPTRACK_BUILD_GUI)
    find_package(Qt5 5.10.0 ${REQUIRED_IN_APPIMAGE} NO_MODULE OPTIONAL_COMPONENTS Widgets)
    set_package_properties(Qt5 PROPERTIES TYPE RECOMMENDED PURPOSE "Required for the heaptrack_gui executable.")
    find_package(ECM 1.0.0 ${REQUIRED_IN_APPIMAGE} NO_MODULE)
    set_package_properties(ECM PROPERTIES TYPE RECOMMENDED PURPOSE "KDE's extra-cmake-modules, required for the heaptrack_gui executable.")
    if(Qt5_FOUND AND ECM_FOUND)
        set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})
            find_package(KF5 ${REQUIRED_IN_APPIMAGE} COMPONENTS CoreAddons I18n ItemModels ThreadWeaver ConfigWidgets KIO IconThemes)
            find_package(KChart ${REQUIRED_IN_APPIMAGE} "2.6.0")
            set_package_properties(KChart PROPERTIES TYPE RECOMMENDED PURPOSE "Required for the heaptrack_gui executable. Get it from the kdiagram module.")
    endif()
endif()

if (KF5_FOUND)
    add_subdirectory(gui)
endif()

=== src/track/CMakeLists.txt ===
# heaptrack: bash script to inject/preload
configure_file(heaptrack.sh.cmake
    ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/heaptrack @ONLY
)

install(PROGRAMS ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/heaptrack
    DESTINATION ${BIN_INSTALL_DIR}
)

if (HEAPTRACK_USE_LIBUNWIND)
    include_directories(${LIBUNWIND_INCLUDE_DIR})

    add_library(heaptrack_unwind STATIC trace_libunwind.cpp)
    target_link_libraries(heaptrack_unwind LINK_PRIVATE ${LIBUNWIND_LIBRARY})
else()
    add_library(heaptrack_unwind STATIC trace_unwind_tables.cpp)
endif()

if (CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
    set(LIBUTIL_LIBRARY "util")
endif()

set_property(TARGET heaptrack_unwind PROPERTY POSITION_INDEPENDENT_CODE ON)

# heaptrack_preload: track a newly started process
add_library(heaptrack_preload MODULE
    heaptrack_preload.cpp
    libheaptrack.cpp
)

target_link_libraries(heaptrack_preload LINK_PRIVATE
    ${CMAKE_DL_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    ${LIBUTIL_LIBRARY}
    heaptrack_unwind
    rt
)

set_target_properties(heaptrack_preload PROPERTIES
    VERSION ${HEAPTRACK_LIB_VERSION}
    SOVERSION ${HEAPTRACK_LIB_SOVERSION}
    LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${LIB_INSTALL_DIR}/heaptrack"
)

install(TARGETS heaptrack_preload
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}/heaptrack/
)

# heaptrack_inject: track an already running process
add_library(heaptrack_inject MODULE
    heaptrack_inject.cpp
    libheaptrack.cpp
)

target_link_libraries(heaptrack_inject LINK_PRIVATE
    ${CMAKE_DL_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    ${LIBUTIL_LIBRARY}
    heaptrack_unwind
    rt
)

set_target_properties(heaptrack_inject PROPERTIES
    VERSION ${HEAPTRACK_LIB_VERSION}
    SOVERSION ${HEAPTRACK_LIB_SOVERSION}
    LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${LIB_INSTALL_DIR}/heaptrack"
)

install(TARGETS heaptrack_inject
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}/heaptrack/
)

# public API for custom pool allocators or static binaries
install(FILES heaptrack_api.h
    DESTINATION ${CMAKE_INSTALL_PREFIX}/include
)

=== tests/benchmarks/CMakeLists.txt ===
include_directories(
    ../..
    ${Boost_INCLUDE_DIRS}
)

include (CheckCXXSourceCompiles)
check_cxx_source_compiles(
    "#include <malloc.h>
    int main() { return mallinfo().uordblks > 0; }"
    HAVE_MALLOC_H)

if (HAVE_MALLOC_H)
    add_executable(bench_pointermap bench_pointermap.cpp)
    add_executable(bench_pointerhash bench_pointerhash.cpp)

    add_executable(measure_malloc_overhead measure_malloc_overhead.cpp)
endif()

add_executable(bench_linereader bench_linereader.cpp)

if (TARGET heaptrack_gui_private)
    add_executable(bench_parser bench_parser.cpp)
    target_link_libraries(bench_parser sharedprint heaptrack_gui_private)
endif()

if (TARGET Qt5::Core AND Boost_CONTAINER_FOUND)
    add_executable(bench_tree bench_tree.cpp)
    target_include_directories(bench_tree PRIVATE ${Boost_INCLUDE_DIRS})
    target_link_libraries(bench_tree Qt5::Core
    ${Boost_CONTAINER_LIBRARY})
endif()

=== 3rdparty/robin-map/tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)

project(tsl_robin_map_tests)

add_executable(tsl_robin_map_tests "main.cpp" 
                                   "custom_allocator_tests.cpp"
                                   "policy_tests.cpp"
                                   "robin_map_tests.cpp" 
                                   "robin_set_tests.cpp")

target_compile_features(tsl_robin_map_tests PRIVATE cxx_std_11)
                                    
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    target_compile_options(tsl_robin_map_tests PRIVATE -Werror -Wall -Wextra -Wold-style-cast -DTSL_DEBUG -UNDEBUG)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    target_compile_options(tsl_robin_map_tests PRIVATE /bigobj /WX /W3 /DTSL_DEBUG /UNDEBUG)
endif()

# Boost::unit_test_framework
find_package(Boost 1.54.0 REQUIRED COMPONENTS unit_test_framework)
target_link_libraries(tsl_robin_map_tests PRIVATE Boost::unit_test_framework)   

# tsl::robin_map
add_subdirectory(../ ${CMAKE_CURRENT_BINARY_DIR}/tsl)
target_link_libraries(tsl_robin_map_tests PRIVATE tsl::robin_map)

=== src/analyze/gui/CMakeLists.txt ===
set(CMAKE_AUTOMOC 1)

ki18n_wrap_ui(UIFILES
    mainwindow.ui
)

unset(BIN_INSTALL_DIR)
unset(LIB_INSTALL_DIR)
unset(LIBEXEC_INSTALL_DIR)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(ECMAddTests)
include(ECMInstallIcons)
include(ECMAddAppIcon)

configure_file(gui_config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/gui_config.h)

add_compile_options(-Wall)

add_definitions(-DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_USE_QSTRINGBUILDER
)

add_library(heaptrack_gui_private STATIC
    util.cpp
    parser.cpp
)
target_link_libraries(heaptrack_gui_private PUBLIC
    KF5::I18n
    KF5::CoreAddons # KFormat
    KF5::ThreadWeaver
    Qt5::Core
    sharedprint
    pthread
    ${CMAKE_THREAD_LIBS_INIT}
)
target_include_directories(heaptrack_gui_private PUBLIC
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../
    ${Boost_INCLUDE_DIRS}
)

set(SRCFILES
    gui.cpp
    mainwindow.cpp
    treemodel.cpp
    treeproxy.cpp
    costdelegate.cpp
    costheaderview.cpp
    flamegraph.cpp
    stacksmodel.cpp
    topproxy.cpp
    callercalleemodel.cpp
    proxystyle.cpp
    suppressionsmodel.cpp
    resources.qrc
)

ecm_add_app_icon(SRCFILES ICONS
    ${CMAKE_CURRENT_SOURCE_DIR}/128-heaptrack_app_icon.png
    ${CMAKE_CURRENT_SOURCE_DIR}/512-heaptrack_app_icon.png
)

set(LIBRARIES
    Qt5::Widgets
    KF5::ItemModels
    KF5::ConfigWidgets
    KF5::I18n
    KF5::KIOWidgets
    KF5::IconThemes
    sharedprint
    heaptrack_gui_private
)

if (KChart_FOUND)
    list(APPEND SRCFILES
        chartwidget.cpp
        chartmodel.cpp
        chartproxy.cpp
        histogramwidget.cpp
        histogrammodel.cpp
    )
    list(APPEND LIBRARIES
        KChart
    )
endif()

add_executable(heaptrack_gui
    ${SRCFILES}
    ${UIFILES}
)

target_link_libraries(heaptrack_gui
    ${LIBRARIES}
)

install(TARGETS heaptrack_gui
    ${INSTALL_TARGETS_DEFAULT_ARGS}
)

set_target_properties(heaptrack_gui PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}"
)

install(PROGRAMS org.kde.heaptrack.desktop
    DESTINATION ${XDG_APPS_INSTALL_DIR}
)

install(FILES org.kde.heaptrack.appdata.xml
    DESTINATION ${KDE_INSTALL_METAINFODIR}
)

ecm_install_icons(ICONS
  16-apps-heaptrack.png
  22-apps-heaptrack.png
  32-apps-heaptrack.png
  48-apps-heaptrack.png
  64-apps-heaptrack.png
  128-apps-heaptrack.png
  DESTINATION ${KDE_INSTALL_ICONDIR}
  THEME hicolor
)

=== tests/manual/with space/CMakeLists.txt ===
add_executable("my binary" "my binary.cpp")

=== debian/changelog ===
heaptrack (1.3.0-1ubuntu1) jammy; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - debian/tests: Check whether testbed has zstd installed before
      assuming output file format.

 -- Rik Mills <rikmills@kde.org>  Wed, 05 Jan 2022 11:47:08 +0000

heaptrack (1.3.0-1) unstable; urgency=medium

  [ Pino Toscano ]
  * [3904e08] Add upstream GPG signing key
  * [856ed9d] Switch watch file to the canonical tarballs
  * [f99d75c] Remove d/scripts/get_orig_src.sh, no more needed now

  [ Anton Gladky ]
  * [d32ea41] New upstream version 1.3.0
  * [fa46f6b] Update patch
  * [be7a8fa] Update gitlab-ci
  * [025cb91] Bump debhelper from old 12 to 13.
  * [6c2a01a] Set upstream metadata fields: Repository, Repository-Browse.
  * [d0f8508] Update standards version to 4.6.0, no changes needed.

 -- Anton Gladky <gladk@debian.org>  Wed, 29 Dec 2021 20:09:05 +0100

heaptrack (1.2.0-1ubuntu1) impish; urgency=medium

  * debian/tests: Check whether testbed has zstd installed before
    assuming output file format.

 -- Rik Mills <rikmills@kde.org>  Sat, 19 Jun 2021 11:29:28 +0100

heaptrack (1.2.0-1build1) hirsute; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 12 Dec 2020 13:07:11 +0100

=== debian/control ===
Source: heaptrack
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: devel
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               qtbase5-dev,
               qtbase5-dev-tools,
               libkf5kio-dev,
               libkf5configwidgets-dev,
               libkf5threadweaver-dev,
               libkf5itemmodels-dev,
               libkf5i18n-dev,
               libkchart-dev,
               libdwarf-dev,
               libelf-dev,
               extra-cmake-modules,
               libunwind-dev,
               libboost-iostreams-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               zlib1g-dev,
               libzstd-dev,
               libsparsehash-dev
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/science-team/heaptrack
Vcs-Git: https://salsa.debian.org/science-team/heaptrack.git
Homepage: https://github.com/KDE/heaptrack

Package: heaptrack
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libheaptrack (= ${binary:Version})
Description: heap memory profiler for Linux
 Heap memory usage profiler. It uses LD_PRELOAD to track all calls
 to the core memory allocation functions and logs these occurrences.
 Additionally, backtraces are obtained and logged. It can also
 generate a historigram of allocation sizes over the number of
 calls. Heaptrack measures the following:
 .
   * Heap memory consumption (like Massif).
   * Number of calls to allocation functions (like callgrind).
   * Total amount of memory allocated, ignoring deallocations.
   * Leaked memory (like memcheck).
 .
 Heaptrack is notable for it's ability to attach to running processes,
 for consuming substantially less memory than Valgrind, and for not
 reducing an application's interactivity as much as Valgrind does.
 Heaptrack is useful for debugging memory leaks and memory ballooning.
 .
 The package contains the command line tools.

Package: heaptrack-gui
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: heap memory profiler for Linux
 Heap memory usage profiler. It uses LD_PRELOAD to track all calls
 to the core memory allocation functions and logs these occurrences.
 Additionally, backtraces are obtained and logged. It can also
 generate a historigram of allocation sizes over the number of
 calls. Heaptrack measures the following:
 .
   * Heap memory consumption (like Massif).
   * Number of calls to allocation functions (like callgrind).
   * Total amount of memory allocated, ignoring deallocations.
   * Leaked memory (like memcheck).
 .
 Heaptrack is notable for it's ability to attach to running processes,
 for consuming substantially less memory than Valgrind, and for not
 reducing an application's interactivity as much as Valgrind does.
 Heaptrack is useful for debugging memory leaks and memory ballooning.
 .
 The package contains the GUI for data analysis.

Package: libheaptrack
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: heap memory profiler for Linux
 Heap memory usage profiler. It uses LD_PRELOAD to track all calls
 to the core memory allocation functions and logs these occurrences.
 Additionally, backtraces are obtained and logged. It can also
 generate a historigram of allocation sizes over the number of
 calls. Heaptrack measures the following:
 .
   * Heap memory consumption (like Massif).
   * Number of calls to allocation functions (like callgrind).
   * Total amount of memory allocated, ignoring deallocations.
   * Leaked memory (like memcheck).
 .
 Heaptrack is notable for it's ability to attach to running processes,
 for consuming substantially less memory than Valgrind, and for not
 reducing an application's interactivity as much as Valgrind does.
 Heaptrack is useful for debugging memory leaks and memory ballooning.
 .
 The package contains the shared libraries.

=== debian/watch ===
version=4
https://download.kde.org/stable/heaptrack/([\d.]+)/@PACKAGE@-([\d.]+)\.tar\.xz

## heaptrack 1.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,9 +14,9 @@
 endif()
 
 set(HEAPTRACK_VERSION_MAJOR 1)
-set(HEAPTRACK_VERSION_MINOR 3)
+set(HEAPTRACK_VERSION_MINOR 4)
 set(HEAPTRACK_VERSION_PATCH 0)
-set(HEAPTRACK_LIB_VERSION 1.3.0)
+set(HEAPTRACK_LIB_VERSION 1.4.0)
 set(HEAPTRACK_LIB_SOVERSION 2)
 set(HEAPTRACK_FILE_FORMAT_VERSION 3)
 
@@ -169,7 +169,8 @@
 add_subdirectory(src)
 add_subdirectory(tests)
 
+# Let releaseme know about this:
+# SKIP_PO_INSTALL
+# (KF5I18n is optional in src/analyze/CMakeLists.txt...)
+
 feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)
-
-find_package(KF5I18n CONFIG REQUIRED)
-ki18n_install(po)

=== tests/CMakeLists.txt ===
if (HEAPTRACK_BUILD_TRACK AND BUILD_TESTING)
    include_directories(${CMAKE_CURRENT_SOURCE_DIR})
    add_subdirectory(manual)
    add_subdirectory(auto)
    add_subdirectory(benchmarks)
endif()

=== 3rdparty/libbacktrace/CMakeLists.txt ===
--- 
+++ 
@@ -30,8 +30,6 @@
 # STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 # IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 # POSSIBILITY OF SUCH DAMAGE.  */
-
-cmake_minimum_required (VERSION 2.8)
 
 project (libbacktrace)

=== src/analyze/CMakeLists.txt ===
--- 
+++ 
@@ -41,6 +41,9 @@
             find_package(KF5 ${REQUIRED_IN_APPIMAGE} COMPONENTS CoreAddons I18n ItemModels ThreadWeaver ConfigWidgets KIO IconThemes)
             find_package(KChart ${REQUIRED_IN_APPIMAGE} "2.6.0")
             set_package_properties(KChart PROPERTIES TYPE RECOMMENDED PURPOSE "Required for the heaptrack_gui executable. Get it from the kdiagram module.")
+        if(KF5I18n_FOUND)
+            ki18n_install(../../po)
+        endif()
     endif()
 endif()

=== src/interpret/CMakeLists.txt ===
if (ECM_FOUND)
    include(ECMEnableSanitizers)
endif()

include_directories(
    ${PROJECT_SOURCE_DIR}/3rdparty/
)

add_definitions("-DHAVE_STDINT_H")

add_executable(heaptrack_interpret
    heaptrack_interpret.cpp
)

target_link_libraries(heaptrack_interpret
    backtrace
)

install(TARGETS heaptrack_interpret
    RUNTIME DESTINATION ${LIBEXEC_INSTALL_DIR}
)

set_target_properties(heaptrack_interpret PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${LIBEXEC_INSTALL_DIR}"
)

=== src/track/CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,17 @@
 endif()
 
 set_property(TARGET heaptrack_unwind PROPERTY POSITION_INDEPENDENT_CODE ON)
+
+# heaptrack_env: runtime environment tests
+add_executable(heaptrack_env heaptrack_env.cpp)
+
+install(TARGETS heaptrack_env
+    RUNTIME DESTINATION ${LIBEXEC_INSTALL_DIR}
+)
+
+set_target_properties(heaptrack_env PROPERTIES
+    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${LIBEXEC_INSTALL_DIR}"
+)
 
 # heaptrack_preload: track a newly started process
 add_library(heaptrack_preload MODULE

=== tests/auto/CMakeLists.txt ===
if (ECM_FOUND)
    include(ECMEnableSanitizers)
endif()

set(CMAKE_BUILD_TYPE Debug)
configure_file(tst_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/tst_config.h @ONLY)

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../
    ${CMAKE_CURRENT_SOURCE_DIR}/../../src
)

add_executable(tst_trace tst_trace.cpp)
target_link_libraries(tst_trace heaptrack_unwind)
target_compile_definitions(tst_trace PRIVATE -DCATCH_CONFIG_MAIN)
add_test(NAME tst_trace COMMAND tst_trace)

if ("${Boost_FILESYSTEM_FOUND}" AND "${Boost_SYSTEM_FOUND}")
    if (CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
        set(LIBUTIL_LIBRARY "util")
    endif()

    include_directories(
        ${Boost_INCLUDE_DIRS}
        ${CMAKE_CURRENT_BINARY_DIR}/../../src/
        ${CMAKE_CURRENT_SOURCE_DIR}/../../src/track
    )
    add_executable(tst_libheaptrack
        tst_libheaptrack.cpp
        ../../src/track/libheaptrack.cpp)
    target_compile_definitions(tst_libheaptrack PRIVATE -DCATCH_CONFIG_MAIN)
    target_link_libraries(tst_libheaptrack
        LINK_PRIVATE
            ${CMAKE_DL_LIBS}
            ${CMAKE_THREAD_LIBS_INIT}
            ${LIBUTIL_LIBRARY}
            heaptrack_unwind
            rt
            ${Boost_SYSTEM_LIBRARY}
            ${Boost_FILESYSTEM_LIBRARY}
    )
    add_test(NAME tst_libheaptrack COMMAND tst_libheaptrack)

    add_executable(tst_io tst_io.cpp)
    target_compile_definitions(tst_io PRIVATE -DCATCH_CONFIG_MAIN)
    target_link_libraries(tst_io
            ${Boost_SYSTEM_LIBRARY}
            ${Boost_FILESYSTEM_LIBRARY}
    )
    add_test(NAME tst_io COMMAND tst_io)

    if (TARGET heaptrack_gui_private)
        find_package(Qt5 5.2.0 CONFIG OPTIONAL_COMPONENTS Test)
        if (Qt5Test_FOUND)
            add_executable(tst_parser tst_parser.cpp)
            target_link_libraries(tst_parser
                    ${Boost_SYSTEM_LIBRARY}
                    ${Boost_FILESYSTEM_LIBRARY}
                    heaptrack_gui_private
                    Qt5::Test
            )
            target_compile_definitions(tst_parser PRIVATE -DCATCH_CONFIG_RUNNER)
            add_test(NAME tst_parser COMMAND tst_parser)
        endif()
    endif()

    add_executable(tst_inject tst_inject.cpp)
    target_compile_definitions(tst_inject PRIVATE -DCATCH_CONFIG_MAIN)
    target_link_libraries(tst_inject
            ${CMAKE_DL_LIBS}
            ${Boost_SYSTEM_LIBRARY}
            ${Boost_FILESYSTEM_LIBRARY}
    )
    add_test(NAME tst_inject COMMAND tst_inject)

endif()

=== tests/benchmarks/CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 include (CheckCXXSourceCompiles)
 check_cxx_source_compiles(
     "#include <malloc.h>
-    int main() { return mallinfo().uordblks > 0; }"
+    int main() { return mallinfo2().uordblks > 0; }"
     HAVE_MALLOC_H)
 
 if (HAVE_MALLOC_H)

=== debian/changelog ===
heaptrack (1.4.0-3ubuntu3) noble; urgency=medium

  * Update fix_ftbfs_gcc-13.patch with more comprehensive fix from
    upsteam git.

 -- Rik Mills <rikmills@kde.org>  Fri, 22 Dec 2023 13:35:55 +0000

heaptrack (1.4.0-3ubuntu2) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:50:28 +0100

heaptrack (1.4.0-3ubuntu1) mantic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - debian/tests: Check whether testbed has zstd installed before
      assuming output file format.

 -- Rik Mills <rikmills@kde.org>  Sat, 16 Sep 2023 15:15:47 +0100

heaptrack (1.4.0-3) unstable; urgency=medium

  * [69ac2b2] Disable tst_trace test, fails on arm64

 -- Anton Gladky <gladk@debian.org>  Tue, 12 Sep 2023 19:11:02 +0200

heaptrack (1.4.0-2.1ubuntu1) mantic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - debian/tests: Check whether testbed has zstd installed before
      assuming output file format.

 -- Rik Mills <rikmills@kde.org>  Sat, 09 Sep 2023 18:36:00 +0100

heaptrack (1.4.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches/fix_ftbfs_gcc-13.patch: New. Fix FTBFS with gcc-13.
    Thanks to Heiko Becker (Closes: #1037688).

 -- Marcos Talau <talau@debian.org>  Thu, 07 Sep 2023 13:48:39 +0530

heaptrack (1.4.0-2ubuntu1) lunar; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - debian/tests: Check whether testbed has zstd installed before
      assuming output file format.

 -- Rik Mills <rikmills@kde.org>  Wed, 09 Nov 2022 06:04:47 +0000

heaptrack (1.4.0-2) unstable; urgency=medium

  [ Christian Göttsche ]
  * [8e471bc] d/control: specify Rules-Requires-Root no
  * [f67042b] d/rules: enable hardening
  * [c399e4d] d/rules: enable LTO

  [ Anton Gladky ]
  * [2aa7315] Fix autopkgtests

 -- Anton Gladky <gladk@debian.org>  Wed, 02 Nov 2022 16:22:23 +0100

heaptrack (1.4.0-1) unstable; urgency=medium

  [ Helmut Grohne ]
  * [e8a65e9] Fix FTCBFS: Build the same way as natively. (Closes: #979280)

  [ Anton Gladky ]
  * [fd99eea] New upstream version 1.4.0
  * [f4e6cdd] Update standards version to 4.6.1, no changes needed.

 -- Anton Gladky <gladk@debian.org>  Fri, 21 Oct 2022 21:41:20 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: heaptrack
-Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Anton Gladky <gladk@debian.org>
 Section: devel
@@ -26,7 +26,8 @@
                zlib1g-dev,
                libzstd-dev,
                libsparsehash-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
+Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/science-team/heaptrack
 Vcs-Git: https://salsa.debian.org/science-team/heaptrack.git
 Homepage: https://github.com/KDE/heaptrack
